#include <avr/io.h>           // I/O  Ǿ ִ  
#include <avr/pgmspace.h>

//old avr compatible definition  by projectmall
#define cbi(sfr, bit) (_SFR_BYTE(sfr) &= ~_BV(bit))
#define sbi(sfr, bit) (_SFR_BYTE(sfr) |= _BV(bit))
#define inb(sfr) _SFR_BYTE(sfr)
#define outb(sfr, val) (_SFR_BYTE(sfr) = (val))
#define outp(val, sfr) outb(sfr, val)
#define inp(sfr) inb(sfr)
#define BV(bit) _BV(bit)

// PRG_RDB => no longer defined in avr-libc
#ifndef PRG_RDB
#define 	PRG_RDB(addr)   pgm_read_byte(addr)
#endif


#define  LDM_ENABLE   PORTD &= ~(1<<PD6);  //active low@VERSION2, active high@VERSION1
#define  LDM_DISABLE  PORTD |=  (1<<PD6);  

// PF0-PF3 : 
#define  RED      PF0       //  
#define  GREEN    PF1       //  
#define  LATCH    PF2      // ġ
#define  CLOCK    PF3      // Ŭ
							
unsigned char font_c;              // Ʈ ī
unsigned long font1;                // Ʈ 

								
unsigned long  __attribute__ ((progmem)) FONT[] = { 
	0x0000,0x7ffc,0x0004,0x0004,
    0x0004,0x0004,0x3ffc,0x0004,
    0x0004,0x0004,0x0004,0x7ffc,
    0x0000,0x0000,0x7ffe,0x0000	
};


// 
int main(void)
{
  unsigned char i,j,addr,state,temp;
  unsigned int Ptr;
  
   outp( 0xff, DDRF );    // PORTB Ʈ 
   outp( 0, PORTF );      // Ʈ  OFF
   state = 0;
   DDRD |= (1<<PD6);
   LDM_ENABLE;

   do{
     for (j = 0; j < 255; j++){
      font_c = 0;                     // Ʈ ī ʱ 
      for (addr=0; addr < 16; addr++){ // 巹 0-15 

        // Ʈ 
        Ptr = &FONT[addr]; //
        font1 = (unsigned long)(PRG_RDB( Ptr++ ));
        font1 |= (unsigned long)(PRG_RDB( Ptr++ )) << 8;
        font1 |= (unsigned long)(PRG_RDB( Ptr++)) << 16;
        font1 |= (unsigned long)(PRG_RDB( Ptr )) << 24;
        
        for (i=0; i < 16; i++){        //  0-15 
		
          if (font1 & 0x01){           // Ʈ on
             if (state == 0) {
               sbi( PORTF, RED ); cbi( PORTF, GREEN );           // 
               } // if
             else if (state == 1){     // 
               cbi( PORTF, RED ); sbi( PORTF, GREEN );
               } // else if
             else {                    // ڹ
               sbi( PORTF, RED ); sbi( PORTF, GREEN );
              } // else
             }  // if
          else {
            cbi( PORTF, RED ); cbi( PORTF, GREEN ); // OFF
            }   // else
          // Ŭ 
          sbi( PORTF, CLOCK );
          cbi( PORTF, CLOCK );
          font1 >>= 1;
         }  // i   for 
         // 巹 
         outp( 0x00, DDRE );
         temp = inp(PINE);
         outp( 0xff, DDRE );
         outp( (((temp) & 0xf0) | addr), PORTE );

         // ġ 
         
         cbi( PORTF, LATCH );
		 sbi( PORTF, LATCH );
		 
        //   ð
        for (i=0; i < 100; i++){
           sbi( PORTF, CLOCK );              // Ŭ 
           cbi( PORTF, CLOCK );
         } //   ð for 
       }  // addr for 
      } // j-for 
        //  Ʈ
        state++;
        if(state == 3) state=0;
     }while(1);            //  
}

