#include <avr/io.h>           // I/O  Ǿ ִ  
#include <avr/pgmspace.h>

//old avr compatible definition  by projectmall
#define cbi(sfr, bit) (_SFR_BYTE(sfr) &= ~_BV(bit))
#define sbi(sfr, bit) (_SFR_BYTE(sfr) |= _BV(bit))
#define inb(sfr) _SFR_BYTE(sfr)
#define outb(sfr, val) (_SFR_BYTE(sfr) = (val))
#define outp(val, sfr) outb(sfr, val)
#define inp(sfr) inb(sfr)
#define BV(bit) _BV(bit)

// PRG_RDB => no inter defined in avr-libc
#ifndef PRG_RDB
#define 	PRG_RDB(addr)   pgm_read_byte(addr)
#endif


#define  LDM_ENABLE   PORTD &= ~(1<<PD6);  //active low @VERSION2, active high @VERSION1
#define  LDM_DISABLE  PORTD |=  (1<<PD6);  

// PF0-PF3 : 
#define  RED      PF0       //  
#define  GREEN    PF1       //  
#define  LATCH    PF2      // ġ
#define  CLOCK    PF3      // Ŭ
							

// "^^" Ʈ
unsigned int  FONT[16] = {
        
        0x0180,0x03c0,0x07e0,0x0db0,0x1998,0x318c,0x6186,0xc183,   
        0x8181,0x0180,0x0180,0x0180,0x0180,0x0180,0x0180,0x0180


};

unsigned char font_c;     // Ʈ ī
unsigned char d_font0;    // Ʈ ī
unsigned char state;      // Ʈ  
unsigned int font;       // Ʈ 
unsigned int buffer[80]; // Ʈ ִϸ̼ 
// ÷
void DISP(void)
{
   unsigned char addr,i, temp;
    for (addr=0; addr < 16; addr++){  // 巹 0-15 
       font = buffer[addr];            // Ʈ 
       for (i=0; i < 16; i++){         //  0-15 
       if (font & 0x01){       // Ʈ on
        
			if (state == 0){  
				sbi( PORTF, RED ); cbi( PORTF, GREEN );         // 
				 
			}else if (state == 1){
				cbi( PORTF, RED ); sbi( PORTF, GREEN );         // 	
			}else{
				sbi( PORTF, RED ); sbi( PORTF, GREEN );         // Ȳ
			}
		
        }else{
		
			cbi( PORTF, RED ); cbi( PORTF, GREEN );         //
		}	
		
		sbi( PORTF, CLOCK );                 // Ŭ 
        cbi( PORTF, CLOCK );
          font >>= 1;
    }  // i   for 
   
        // 巹

		
        outp( 0x00, DDRE );
        outp( ~addr, PORTE );//UP/DOWN
        outp( 0xff, DDRE );
		
        sbi( PORTF, LATCH );               // ġ
        cbi( PORTF, LATCH );
        //   ð
        for (i=0; i < 20; i++){
           sbi( PORTF, CLOCK );              // Ŭ 
           cbi( PORTF, CLOCK );
         } //   ð for 
       } // addr for 
}
// Ʈ ε
 void LOAD( unsigned char i)
{
    unsigned char  j,k;
    unsigned int Ptr;
	
    k = i;                               // Ʈ ī 
    i++;
    d_font0 = 0;                         // Ʈ 
    for (j=0; j<16; j++) buffer[j]= 0;   //  Ŭ
    for( ; i > 0;  i-- )  {              // Ʈ īͰ 0϶ 
      
      buffer[15-k] = FONT[d_font0++];;    // ÷ ۿ 
      k--;
    }
}

// 
int main(void)
{
   unsigned char ld_cnt, count2;
   DDRD |= (1<<PD6);
   LDM_ENABLE;
   outp( 0xff, DDRF );     // B Ʈ 
   outp( 0x00, PORTF );    // Ʈ  OFF
   state = 0;       // Ʈ ʱ 
   do{
       // Ʈ ʷ ε
       for (ld_cnt=0; ld_cnt < 16; ld_cnt++){
          LOAD(ld_cnt);                         // Ʈ ε
          // 50 ÷
         for(count2=0; count2 < 50; count2++) DISP();
        }  // for
          // 200 ÷( ȿ)
         for(count2=0; count2 < 200; count2++) DISP();
		 state++;
		 if(state==3) state = 0;
        
  }while(1);                        //  
}


